#ifndef FRAMECPP__COMMON__Description_HH
#define FRAMECPP__COMMON__Description_HH

#if ! defined(SWIGIMPORTED)
#include <list>
#endif /* ! defined(SWIGIMPORTED) */

#include "general/SharedPtr.hh"

#include "framecpp/Common/FrameSpec.hh"

namespace FrameCPP
{
  namespace Common
  {
    class OFrameStream;

    class Description
    {
    public:
      typedef General::SharedPtr< FrameSpec::Object > object_type;

      virtual ~Description( );

      const std::string& GetName( ) const;

      void Write( OFrameStream& Stream ) const;

      void operator( )( object_type Obj );

      void operator( )( const object_type::element_type& Obj );

      INT_4U size( ) const;

    private:
      typedef std::list< object_type > description_container;

      description_container	m_desc;
    };

    inline INT_4U Common::Description::
    size( ) const
    {
      return m_desc.size( );
    }

  } // namespace - Common
} // namespace - FrameCPP

#endif /* FRAMECPP__COMMON__Description_HH */

